[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Annotation of openbsd/fw_update/fw_install.sh, Revision 1.140

1.1       afresh1     1: #!/bin/ksh
1.36      afresh1     2: #      $OpenBSD$
1.50      afresh1     3: #
1.38      afresh1     4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17:
1.95      afresh1    18: set -o errexit -o pipefail -o nounset -o noclobber -o noglob
1.85      afresh1    19: set +o monitor
1.77      afresh1    20: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50      afresh1    21:
                     22: CFILE=SHA256.sig
                     23: DESTDIR=${DESTDIR:-}
                     24: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                     25:
                     26: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
                     27: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
                     28:
                     29: HTTP_FWDIR="$VNAME"
1.52      afresh1    30: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
                     31:     /var/run/dmesg.boot | sed '$!d' )
1.50      afresh1    32: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22      afresh1    33:
1.50      afresh1    34: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
                     35: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8       afresh1    36:
1.131     afresh1    37: DRYRUN=false
1.138     afresh1    38: VERBOSE=0
1.111     afresh1    39: DELETE=false
1.87      afresh1    40: DOWNLOAD=true
                     41: INSTALL=true
1.69      afresh1    42: LOCALSRC=
                     43:
1.126     afresh1    44: unset FTPPID
1.129     afresh1    45: unset FWPKGTMP
1.126     afresh1    46: REMOVE_LOCALSRC=false
                     47: cleanup() {
1.127     afresh1    48:        set +o errexit # ignore errors from killing ftp
1.128     afresh1    49:        [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
1.129     afresh1    50:        [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
1.126     afresh1    51:        "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
                     52: }
                     53: trap cleanup EXIT
                     54:
1.8       afresh1    55: tmpdir() {
                     56:        local _i=1 _dir
                     57:
1.50      afresh1    58:        # If we're not in the installer,
1.79      afresh1    59:        # we have mktemp and a more hostile environment.
1.50      afresh1    60:        if [ -x /usr/bin/mktemp ]; then
                     61:                _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44      afresh1    62:        else
1.50      afresh1    63:                until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44      afresh1    64:                    ((++_i < 10000)) || return 1
                     65:                done
                     66:        fi
1.50      afresh1    67:
1.8       afresh1    68:        echo "$_dir"
                     69: }
1.6       afresh1    70:
1.50      afresh1    71: fetch() {
1.126     afresh1    72:        local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
1.6       afresh1    73:
1.79      afresh1    74:        # If we're not in the installer,
                     75:        # we have su(1) and doas(1) is unlikely to be configured.
1.85      afresh1    76:        set -o monitor # make sure ftp gets its own process group
                     77:        (
1.138     afresh1    78:        _flags=-vm
                     79:        case "$VERBOSE" in
                     80:                0|1) _flags=-VM ;;
                     81:                  2) _flags=-Vm ;;
                     82:        esac
1.53      afresh1    83:        if [ -x /usr/bin/su ]; then
1.85      afresh1    84:                exec /usr/bin/su -s /bin/ksh "$_user" -c \
1.138     afresh1    85:                    "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $_flags -o- '$_src'" > "$_dst"
1.42      afresh1    86:        else
1.85      afresh1    87:                exec /usr/bin/doas -u "$_user" \
1.138     afresh1    88:                    /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $_flags -o- "$_src" > "$_dst"
1.42      afresh1    89:        fi
1.126     afresh1    90:        ) & FTPPID=$!
1.85      afresh1    91:        set +o monitor
                     92:
                     93:        SECONDS=0
                     94:        _last=0
1.126     afresh1    95:        while kill -0 -"$FTPPID" 2>/dev/null; do
1.85      afresh1    96:                if [[ $SECONDS -gt 12 ]]; then
                     97:                        set -- $( ls -ln "$_dst" 2>/dev/null )
                     98:                        if [[ $_last -ne $5 ]]; then
                     99:                                _last=$5
                    100:                                SECONDS=0
                    101:                                sleep 1
                    102:                        else
1.137     afresh1   103:                                kill -INT -"$FTPPID" 2>/dev/null
1.92      afresh1   104:                                _error=" (timed out)"
1.85      afresh1   105:                        fi
                    106:                else
                    107:                        sleep 1
                    108:                fi
                    109:        done
                    110:
                    111:        set +o errexit
1.126     afresh1   112:        wait "$FTPPID"
1.85      afresh1   113:        _exit=$?
                    114:        set -o errexit
                    115:
1.126     afresh1   116:        unset FTPPID
1.6       afresh1   117:
1.50      afresh1   118:        if [ "$_exit" -ne 0 ]; then
1.69      afresh1   119:                rm -f "$_dst"
1.92      afresh1   120:                echo "Cannot fetch $_src$_error" >&2
1.50      afresh1   121:                return 1
                    122:        fi
1.6       afresh1   123: }
                    124:
1.50      afresh1   125: verify() {
                    126:        # On the installer we don't get sha256 -C, so fake it.
1.69      afresh1   127:        if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                    128:                echo "Checksum test for ${1##*/} failed." >&2
1.50      afresh1   129:                return 1
                    130:        fi
1.6       afresh1   131: }
                    132:
1.124     afresh1   133: firmware_in_dmesg() {
1.90      afresh1   134:        local _d _m _line _dmesgtail _last='' _nl=$( echo )
1.1       afresh1   135:
1.50      afresh1   136:        # When we're not in the installer, the dmesg.boot can
                    137:        # contain multiple boots, so only look in the last one
1.133     afresh1   138:        _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )"
1.50      afresh1   139:
1.89      afresh1   140:        grep -v '^[[:space:]]*#' "$FWPATTERNS" |
                    141:            while read -r _d _m; do
                    142:                [ "$_d" = "$_last" ] && continue
1.90      afresh1   143:                [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                    144:                [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
1.83      afresh1   145:
1.89      afresh1   146:                if [[ $_dmesgtail = *$_m* ]]; then
                    147:                        echo "$_d"
                    148:                        _last="$_d"
                    149:                fi
                    150:            done
1.50      afresh1   151: }
1.14      afresh1   152:
1.50      afresh1   153: firmware_filename() {
1.56      afresh1   154:        local _f
                    155:        _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
                    156:        ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
                    157:        echo "$_f"
1.50      afresh1   158: }
1.7       afresh1   159:
1.57      afresh1   160: firmware_devicename() {
                    161:        local _d="${1##*/}"
                    162:        _d="${_d%-firmware-*}"
                    163:        echo "$_d"
                    164: }
                    165:
1.50      afresh1   166: installed_firmware() {
1.110     afresh1   167:        local _pre="$1" _match="$2" _post="$3" _firmware
1.123     afresh1   168:        set -sA _firmware -- $(
1.109     afresh1   169:            set +o noglob
                    170:            grep -Fxl '@option firmware' \
1.110     afresh1   171:                "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
1.109     afresh1   172:                2>/dev/null || true
                    173:            set -o noglob
                    174:        )
                    175:
                    176:        [ "${_firmware[*]:-}" ] || return 0
                    177:        for fw in "${_firmware[@]}"; do
                    178:                fw="${fw%/+CONTENTS}"
1.50      afresh1   179:                echo "${fw##*/}"
                    180:        done
                    181: }
1.1       afresh1   182:
1.124     afresh1   183: detect_firmware() {
                    184:        local _devices _last='' _d
                    185:
                    186:        set -sA _devices -- $(
                    187:            firmware_in_dmesg
                    188:            for _d in $( installed_firmware '*' '-firmware-' '*' ); do
1.135     afresh1   189:                firmware_devicename "$_d"
1.124     afresh1   190:            done
                    191:        )
                    192:
                    193:        [ "${_devices[*]:-}" ] || return 0
                    194:        for _d in "${_devices[@]}"; do
1.135     afresh1   195:                [ "$_last" = "$_d" ] && continue
                    196:                echo "$_d"
1.124     afresh1   197:                _last="$_d"
                    198:        done
                    199: }
                    200:
1.50      afresh1   201: add_firmware () {
1.139     afresh1   202:        local _f="${1##*/}" _m="${2:-Install}" _pkgname
1.129     afresh1   203:        FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
1.138     afresh1   204:        local _flags=-vm
                    205:        case "$VERBOSE" in
                    206:                0|1) _flags=-VM ;;
                    207:                2|3) _flags=-Vm ;;
                    208:        esac
                    209:
1.139     afresh1   210:        ftp -N "${0##/}" -D "$_m" "$_flags" -o- "file:${1}" |
1.129     afresh1   211:                tar -s ",^\+,${FWPKGTMP}/+," \
1.69      afresh1   212:                    -s ",^firmware,${DESTDIR}/etc/firmware," \
                    213:                    -C / -zxphf - "+*" "firmware/*"
1.1       afresh1   214:
1.129     afresh1   215:        _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
1.106     afresh1   216:        if [ ! "$_pkgname" ]; then
                    217:                echo "Failed to extract name from $1, partial install" 2>&1
1.129     afresh1   218:                rm -rf "$FWPKGTMP"
                    219:                unset FWPKGTMP
1.106     afresh1   220:                return 1
                    221:        fi
                    222:
1.50      afresh1   223:        # TODO: Should we mark these so real fw_update can -Drepair?
1.129     afresh1   224:        ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
1.50      afresh1   225: /^@comment pkgpath/ -1a
                    226: @option manual-installation
                    227: @option firmware
                    228: @comment install-script
                    229: .
                    230: w
                    231: EOL
1.106     afresh1   232:
1.129     afresh1   233:        chmod 755 "$FWPKGTMP"
                    234:        mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
                    235:        unset FWPKGTMP
1.50      afresh1   236: }
1.22      afresh1   237:
1.50      afresh1   238: delete_firmware() {
1.51      afresh1   239:        local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22      afresh1   240:
1.50      afresh1   241:        # TODO: Check hash for files before deleting
1.140   ! afresh1   242:        [ "$VERBOSE" -gt 2 ] && echo -n "Uninstall $_pkg ..."
1.51      afresh1   243:        _cwd="${_pkgdir}/$_pkg"
1.50      afresh1   244:
1.107     afresh1   245:        if [ ! -e "$_cwd/+CONTENTS" ] ||
                    246:            ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
                    247:                echo "${0##*/}: $_pkg does not appear to be firmware" >&2
                    248:                return 2
                    249:        fi
                    250:
1.51      afresh1   251:        set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50      afresh1   252:
                    253:        while read -r c g; do
                    254:                case $c in
1.51      afresh1   255:                @cwd) _cwd="${DESTDIR}$g"
1.50      afresh1   256:                  ;;
                    257:                @*) continue
                    258:                  ;;
1.52      afresh1   259:                *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50      afresh1   260:                  ;;
                    261:                esac
                    262:        done < "${_pkgdir}/${_pkg}/+CONTENTS"
                    263:
                    264:        # We specifically rm -f here because not removing files/dirs
                    265:        # is probably not worth failing over.
                    266:        for _r in "${_remove[@]}" ; do
                    267:                if [ -d "$_r" ]; then
                    268:                        # Try hard not to actually remove recursively
                    269:                        # without rmdir on the install media.
1.95      afresh1   270:                        set +o noglob
1.50      afresh1   271:                        [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
1.95      afresh1   272:                        set -o noglob
1.50      afresh1   273:                else
                    274:                        rm -f "$_r"
1.22      afresh1   275:                fi
                    276:        done
1.138     afresh1   277:
1.140   ! afresh1   278:        [ "$VERBOSE" -gt 2 ] && echo " done."
1.139     afresh1   279:
                    280:        return 0
1.50      afresh1   281: }
1.1       afresh1   282:
1.59      afresh1   283: usage() {
1.122     afresh1   284:        echo "usage:  ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
1.59      afresh1   285:        exit 2
                    286: }
                    287:
1.113     afresh1   288: ALL=false
1.87      afresh1   289: OPT_D=
1.131     afresh1   290: while getopts :adDnp:v name
1.59      afresh1   291: do
                    292:        case "$name" in
1.113     afresh1   293:        a) ALL=true ;;
1.111     afresh1   294:        d) DELETE=true ;;
1.87      afresh1   295:        D) OPT_D=true ;;
1.131     afresh1   296:        n) DRYRUN=true ;;
1.121     afresh1   297:        p) LOCALSRC="$OPTARG" ;;
1.138     afresh1   298:        v) VERBOSE=$(( VERBOSE + 1 )) ;;
1.121     afresh1   299:        :)
                    300:           echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
                    301:           usage 2
                    302:           ;;
                    303:        ?)
                    304:           echo "${0##*/}: unknown option -- -$OPTARG" >&2
                    305:           usage 2
                    306:           ;;
1.59      afresh1   307:        esac
                    308: done
                    309: shift $((OPTIND - 1))
                    310:
1.121     afresh1   311: if [ "$LOCALSRC" ]; then
                    312:        if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
                    313:                FWURL="${LOCALSRC}"
                    314:                LOCALSRC=
                    315:        else
                    316:                LOCALSRC="${LOCALSRC:#file:}"
                    317:                ! [ -d "$LOCALSRC" ] &&
                    318:                    echo "The path must be a URL or an existing directory" >&2 &&
                    319:                    exit 2
                    320:        fi
                    321: fi
                    322:
1.122     afresh1   323: # "Download only" means local dir and don't install
1.87      afresh1   324: if [ "$OPT_D" ]; then
                    325:        INSTALL=false
1.121     afresh1   326:        LOCALSRC="${LOCALSRC:-.}"
1.130     afresh1   327: elif [ "$LOCALSRC" ]; then
                    328:        DOWNLOAD=false
1.87      afresh1   329: fi
1.64      afresh1   330:
1.118     afresh1   331: if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
                    332:        echo "need root privileges" >&2
                    333:        exit 1
1.94      afresh1   334: fi
                    335:
1.123     afresh1   336: set -sA devices -- "$@"
1.111     afresh1   337:
                    338: if "$DELETE"; then
1.122     afresh1   339:        [ "$OPT_D" ] && usage 22
1.111     afresh1   340:
1.139     afresh1   341:        # Show the "Uninstalling" message when just deleting not upgrading
1.140   ! afresh1   342:        [ "$VERBOSE" -gt 1 ] && VEROBOSE=3
1.139     afresh1   343:
1.113     afresh1   344:        set -A installed
                    345:        if [ "${devices[*]:-}" ]; then
                    346:                "$ALL" && usage 22
                    347:
                    348:                set -A installed -- $(
                    349:                    for d in "${devices[@]}"; do
                    350:                        f="${d##*/}"  # only care about the name
                    351:                        f="${f%.tgz}" # allow specifying the package name
                    352:                        [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
                    353:
                    354:                        set -A i -- $( installed_firmware '' "$f-" '*' )
                    355:
                    356:                        if [ "${i[*]:-}" ]; then
                    357:                                echo "${i[@]}"
                    358:                        else
                    359:                                echo "No firmware found for '$d'" >&2
                    360:                        fi
                    361:                    done
                    362:                )
                    363:        elif "$ALL"; then
                    364:                set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
                    365:        fi
1.111     afresh1   366:
                    367:        deleted=''
1.113     afresh1   368:        if [ "${installed:-}" ]; then
1.111     afresh1   369:                for fw in "${installed[@]}"; do
1.131     afresh1   370:                        if "$DRYRUN"; then
1.138     afresh1   371:                                [ "$VERBOSE" -gt 0 ] && echo "Delete $fw"
1.131     afresh1   372:                        else
                    373:                                delete_firmware "$fw" || continue
                    374:                        fi
1.112     afresh1   375:                        deleted="$deleted,$( firmware_devicename "$fw" )"
1.111     afresh1   376:                done
1.113     afresh1   377:        fi
1.111     afresh1   378:
1.139     afresh1   379:        deleted="${deleted#,}"
1.111     afresh1   380:        echo "${0:##*/}: deleted ${deleted:-none}";
                    381:
                    382:        exit
                    383: fi
1.125     afresh1   384:
                    385: if [ ! "$LOCALSRC" ]; then
                    386:     LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
1.126     afresh1   387:     REMOVE_LOCALSRC=true
1.125     afresh1   388: fi
                    389:
                    390: CFILE="$LOCALSRC/$CFILE"
1.58      afresh1   391:
1.113     afresh1   392: if [ "${devices[*]:-}" ]; then
                    393:        "$ALL" && usage 22
                    394: else
1.139     afresh1   395:        [ "$VERBOSE" -gt 1 ] && echo -n "Detect firmware ..."
1.124     afresh1   396:        set -sA devices -- $( detect_firmware )
1.139     afresh1   397:        [ "$VERBOSE" -gt 1 ] &&
1.101     afresh1   398:            { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
1.50      afresh1   399: fi
1.91      afresh1   400:
                    401: [ "${devices[*]:-}" ] || exit
1.50      afresh1   402:
1.71      afresh1   403: if "$DOWNLOAD"; then
1.116     afresh1   404:        set +o noclobber # we want to get the latest CFILE
1.64      afresh1   405:        fetch "$CFILE"
1.116     afresh1   406:        set -o noclobber
1.64      afresh1   407:        ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                    408:            echo "Signature check of SHA256.sig failed" >&2 && exit 1
1.120     afresh1   409: elif [ ! -e "$CFILE" ]; then
                    410:        # TODO: We shouldn't need a CFILE if all arguments are files.
                    411:        echo "${0##*/}: $CFILE: No such file or directory" >&2
                    412:        exit 2
1.64      afresh1   413: fi
1.50      afresh1   414:
1.103     afresh1   415: added=''
                    416: updated=''
1.115     afresh1   417: kept=''
1.70      afresh1   418: for f in "${devices[@]}"; do
                    419:        d="$( firmware_devicename "$f" )"
                    420:
1.58      afresh1   421:        if [ "$f" = "$d" ]; then
                    422:                f=$( firmware_filename "$d" || true )
                    423:                [ "$f" ] || continue
1.69      afresh1   424:                f="$LOCALSRC/$f"
1.76      afresh1   425:        elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70      afresh1   426:                echo "Cannot download local file $f" >&2
                    427:                exit 2
1.58      afresh1   428:        fi
                    429:
1.110     afresh1   430:        set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
1.50      afresh1   431:
1.68      afresh1   432:        if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65      afresh1   433:                for i in "${installed[@]}"; do
1.58      afresh1   434:                        if [ "${f##*/}" = "$i.tgz" ]; then
1.139     afresh1   435:                                [ "$VERBOSE" -gt 2 ] && echo "Keep $i"
1.115     afresh1   436:                                kept="$kept,$d"
1.11      afresh1   437:                                continue 2
1.1       afresh1   438:                        fi
                    439:                done
1.50      afresh1   440:        fi
1.1       afresh1   441:
1.72      afresh1   442:        if [ -e "$f" ]; then
                    443:                if "$DOWNLOAD"; then
1.140   ! afresh1   444:                        [ "$VERBOSE" -gt 1 ] && ! "$INSTALL" &&
1.134     afresh1   445:                            echo "Keep/Verify ${f##*/}"
1.131     afresh1   446:                        "$DRYRUN"  || verify "$f" || continue
                    447:                        "$INSTALL" || kept="$kept,$d"
1.72      afresh1   448:                # else assume it was verified when downloaded
                    449:                fi
1.75      afresh1   450:        elif "$DOWNLOAD"; then
1.131     afresh1   451:                if "$DRYRUN"; then
1.138     afresh1   452:                        [ "$VERBOSE" -gt 0 ] && echo "Get/Verify ${f##*/}"
1.131     afresh1   453:                else
1.138     afresh1   454:                        [ "$VERBOSE" -eq 1 ] && echo -n "Get/Verify ${f##*/} ..."
                    455:                        fetch  "$f" &&
                    456:                        verify "$f" ||
                    457:                            { [ "$VERBOSE" -eq 1 ] && echo " failed."; continue; }
1.139     afresh1   458:                        [ "$VERBOSE" -eq 1 ] && ! "$INSTALL" && echo " done."
1.131     afresh1   459:                fi
1.138     afresh1   460:                "$INSTALL" || added="$added,$d"
1.75      afresh1   461:        elif "$INSTALL"; then
1.72      afresh1   462:                echo "Cannot install ${f##*/}, not found" >&2
                    463:                continue
1.58      afresh1   464:        fi
1.60      afresh1   465:
1.68      afresh1   466:        "$INSTALL" || continue
1.11      afresh1   467:
1.139     afresh1   468:        update=''
1.65      afresh1   469:        if [ "${installed[*]:-}" ]; then
1.50      afresh1   470:                for i in "${installed[@]}"; do
1.131     afresh1   471:                        "$DRYRUN" || delete_firmware "$i"
1.139     afresh1   472:                        update="Update"
1.50      afresh1   473:                done
                    474:        fi
1.11      afresh1   475:
1.139     afresh1   476:        "$DRYRUN" || add_firmware "$f" "$update"
1.103     afresh1   477:
1.131     afresh1   478:        f="${f##*/}"
                    479:        f="${f%.tgz}"
1.139     afresh1   480:        if [ "$update" ]; then
1.140   ! afresh1   481:                if [ "$VERBOSE" -eq 1 ] && "$DOWNLOAD" && ! "$DRYRUN"; then
        !           482:                        echo " updated."
1.139     afresh1   483:                elif [ "$VERBOSE" -eq 1 ]; then
1.140   ! afresh1   484:                        echo "Update $f"
        !           485:                elif [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
        !           486:                        echo "Update $f"
1.139     afresh1   487:                fi
1.114     afresh1   488:                updated="$updated,$d"
1.103     afresh1   489:        else
1.140   ! afresh1   490:                if [ "$VERBOSE" -eq 1 ] && "$DOWNLOAD" && ! "$DRYRUN"; then
        !           491:                        echo " installed."
1.139     afresh1   492:                elif [ "$VERBOSE" -eq 1 ]; then
1.140   ! afresh1   493:                        echo "Install $f"
        !           494:                elif [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
        !           495:                        echo "Install $f"
1.139     afresh1   496:                fi
1.114     afresh1   497:                added="$added,$d"
1.103     afresh1   498:        fi
1.50      afresh1   499: done
1.1       afresh1   500:
1.114     afresh1   501: added="${added:#,}"
                    502: updated="${updated:#,}"
1.115     afresh1   503: kept="${kept:#,}"
1.117     afresh1   504: if "$INSTALL"; then
                    505:        echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
                    506: else
                    507:        echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
                    508: fi

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>